package com.loafle.overflow.central.commons.utils;

import com.loafle.overflow.core.model.PageParams;

import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;

/**
 * Created by insanity on 17. 8. 25.
 */
public class PageUtil {
    private static Sort.Direction getSortDirection(String sortDirection) {
        if(sortDirection.equalsIgnoreCase("ascending")) {
            return Sort.Direction.ASC;
        }
        return Sort.Direction.DESC;
    }

    public static PageRequest getPageRequest(PageParams pageParams) {
        if(pageParams.getSortCol().isEmpty()) pageParams.setSortCol("id");
        if(pageParams.getSortDirection().isEmpty()) pageParams.setSortDirection("descending");

        return new PageRequest(pageParams.getPageNo(), pageParams.getCountPerPage(),
                new Sort(PageUtil.getSortDirection(pageParams.getSortDirection()), pageParams.getSortCol()));
    }
}
