package com.loafle.overflow.central.module.sensor.dao;


import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.target.Target;

/**
 * Created by root on 17. 6. 9.
 */
@Repository
public interface SensorDAO extends JpaRepository<Sensor, Long> {

    Page<Sensor> findAllByTarget(Target target, Pageable pageable);
    List<Sensor> findAllByTarget(Target target);

    @Query("SELECT s from Sensor s WHERE s.target in (:targetList)")
    Page<Sensor> findAllByTargetList(@Param("targetList") List<Target> targetList, Pageable pageable);
}
